<?php
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes/common_plugin.class.inc.php');

  /* 
      generic class for translator
        initialize plugin name and tables names list
  */
  class root_translator extends common_plugin
  {
    function root_translator($prefixeTable, $filelocation)
    {
      parent::common_plugin($prefixeTable, $filelocation);
      $this->plugin_name='translator';
      $this->section_name=$this->plugin_name;

      $list=array('files', 'keys', 'langs', 'langs_codes');
      $this->set_tables_list($list);

      $this->statuslist=array(
        'none' => 'g001_filternone',
        'ok' => 'g001_validated',
        'valide_it' => 'g001_to_validate',
        'not_translated' => 'g001_to_translate',
        'deleted' => 'g001_deleted'
      );

    }



    /*
      intialize default values 
    */
    function init_config()
    {
      //global $user;
      $this->my_config=array(
        //if autoscan set to 'y', everytime user acceed "status page", directories
        //are a scanned to see if there is new files, modified files, or deleted files
        'autoscan' => 'y',
        // 
        'mainlang' => 'fr_FR',
        'charset' => 'iso-8859-1',
        //bargraph's color for translate translation (tt)
        'color_bars1' => 'ff0000',
        //bargraph's color for to validate translation (tv)
        'color_bars2' => 'ff9000',
        //bargraph's color for to validated translation (to)
        'color_bars3' => '00ff00',
        //bargraph's color for to validated translation (td)
        'color_bars4' => 'ff00ff',
        //color for row overrided by mouse
        'mouse_over_color' => '303030',
        //width (in px) for graph's bars
        'bars_width' => '115',
        //number of items displayed
        'number_of_items' => 25,
        //default status filter applyed ('none', 'ok', 'valide_it', 'not_translated')
        'default_status_filter' => 'none',
        //additional languages (base assumed : fr_FR.iso-8859-1)
        'additional_langs' => 'fr_FR.iso-8859-1',
        //maximum of items exported by a call to export_phase1
        'export_maximum_items' => 1000,
        //width (in px) for progress bar
        'progress_bar_width' => 400,
        //translator_mode (array of user id)
        'translator_mode' => array()
      );
    }





    /* ---------------------------------------------------------------------------
      base functions
    --------------------------------------------------------------------------- */

    /*
      this function scan directories & sub-directories to find *.lang.php files
      returns an array of filenames

      if $dir is specified, begin scan at $dir directory, else begin scan at PWG root path

      if $charset is specified, search file with the explicit charset, otherwise search file with all charset
    */
    function search_languages_files($dir="", $charset="")
    {
      $returned=array();
      if($dir=="")
      {
        $dir = PHPWG_ROOT_PATH;
      }

      if ($opendir = opendir($dir))
      {
        while ($file = readdir($opendir))
        {
          if ($file != '.'
              and $file != '..'
              and is_dir($dir.'/'.$file)
              and $file != 'CVS'
              and $file != '.svn')
          {
            $returned=array_merge($returned, $this->search_languages_files($dir.'/'.$file, $charset));
          }
          elseif((strpos(strtolower($file), ".lang.php")!==false)&&(get_extension($file)=='php')&&((get_extension($dir)==$charset)||($charset=="")))
          {
//echo $dir."(".get_extension($dir).") (".$charset.")<br>";
            array_push($returned, $dir.'/'.$file);
          }
        }
      }
      return($returned);
    }

    /*
      analyze a ".lang.php" filename and returns
        - filename
        - language
        - file type (pwg or plugins)
        - last date/time of modification (unix timestamp)
        returned as an array
    */
    function analyze_filename($filename)
    {
      $file=basename($filename);
      $language=basename(dirname($filename));
      if(strpos($filename, "/plugins/")!==false)
      {
        $type='plugin';
        $tmp=explode('/plugins/', $filename);
        $tmp=explode('/', $tmp[1]);
        $name=$tmp[0];
        $plugins=get_fs_plugins();
        if(isset($plugins[$name]))
        {
          $version=$plugins[$name]['version'];
        }
        else
        {
          $version='n/a';
        }
      }
      else
      {
        $type='pwg';
        $name='core';
        $version=PHPWG_VERSION;
      }
      return(array(
        'filename' => $filename,
        'file' => $file,
        'lang' => $language,
        'type' => $type,
        'modified' => filemtime($filename),
        'name' => $name,
        'version' => $version
                  ));
    }

    /* ---------------------------------------------------------------------------
      management functions
    --------------------------------------------------------------------------- */
    /*
       dplacer dans le fichier _bo
       grer lors de la premire utilisation du plugin, en prosant une page spcifique
           l'installation du plugin

      load a lang files into database
        $lang : new lang
        $charset : charset to use
        $files_list : list of analyzed files
        $user_id : user who initiate this process
    */
    function load_lang_files($language='', $charset='', $files_list, $user_id)
    {
      $errors=array();
      $yesno=array(true=>'y', false=>'n');
      foreach($files_list as $file)
      {
        if(($file['lang']==$language.'.'.$charset)||($language.$charset==''))
        {
          $sql="INSERT INTO ".$this->tables['files']." VALUES (
            '',
            '".$file['type']."',
            '".basename($file['filename'])."',
            '".$file['lang']."',
            '".$file['version']."',
            '".$file['name']."',
            '".$file['filename']."',
            '0',
            '0',
            '0',
            '0',
            '".date('Y-m-d H:i:s', $file['modified'])."',
            '0'
          )";
          if(pwg_query($sql))
          {
            $id=mysql_insert_id();
            $nbelem=0;
            unset($lang);
            unset($lang_info);
            //include $lang array
            @include($file['filename']);
            //$lang=$this->load_lang_file($file['filename']);
            foreach($lang as $key => $val)
            {
              if(is_array($val))
              {
                while(list($ikey, $ival) = each($val))
                {
                  $sql="INSERT INTO ".$this->tables['keys']." VALUES (
                    '".$key." [#".$ikey."]',
                    '".$id."',
                    '1',
                    '".date('Y-m-d H:i:s')."',
                    '".$user_id."',
                    'valide_it',
                    '".addslashes($ival)."',
                    '0',
                    '0000-00-00 00:00:00',
                    '".$this->calculate_uniquekey($key." [#".$ikey."]", $id)."'
                  )";
                  if(!pwg_query($sql))
                  {
                    array_push($errors, array('T',$key." [#".$ikey."]", $ival));
                  }
                  else
                  {
                    $nbelem++;
                  }
                }
              }
              else
              {
                $sql="INSERT INTO ".$this->tables['keys']." VALUES (
                  '".$key."',
                  '".$id."',
                  '1',
                  '".date('Y-m-d H:i:s')."',
                  '".$user_id."',
                  'valide_it',
                  '".addslashes($val)."',
                  '0',
                  '0000-00-00 00:00:00',
                  '".$this->calculate_uniquekey($key, $id)."'
                )";
                if(!pwg_query($sql))
                {
                  array_push($errors, array('T',$key, $val));
                }
                else
                {
                  $nbelem++;
                }
              }
            }
            
            if(isset($lang_info))
            {
              $tmp=explode('.', $file['lang']);
              $tmp=explode('_', $tmp[0]);

              $sql="INSERT INTO ".$this->tables['langs']." VALUES (
                '".$lang_info['code']."',
                '".$tmp[1]."',
                '".$lang_info['charset']."',
                '".$lang_info['direction']."',
                '".$lang_info['language_name']."',
                '".$lang_info['country']."',
                '".$yesno[$lang_info['zero_plural']]."',
                '".$file['lang']."'
              )";
              $result=pwg_query($sql);
            }

            $sql="UPDATE ".$this->tables['files']."
                  SET nb_elem = '".$nbelem."',
                      nb_to_validate = '".$nbelem."'
                  WHERE id = '".$id."'";
            pwg_query($sql);
          }
          else
          {
            array_push($errors, array('F',$file));
          }
        }
      }
      return($errors);
    }

    function calculate_uniquekey($key, $file)
    {
      return(md5($file.'-'.$key));
    }

  } //class

?>
